#-*- coding: UTF-8 -*-

"""
Some fancy helper functions.
"""

import os
import ctypes
import sys
import structs

from errors import AssimpError
from ctypes import POINTER

def vec2tuple(x):
    """ Converts a VECTOR3D to a Tuple """
    return (x.x, x.y, x.z)


def search_library():
    """Loads the assimp-Library.
    
    result (load-function, release-function)    
    exception AssimpError if no library is found
    
        """

    # silence 'DLL not found' message boxes on win
    try:
        ctypes.windll.kernel32.SetErrorMode(0x8007)
    except AttributeError:
        pass    

    libassimp = 'libassimp.so.3'
    LIBASSIMP = ctypes.CDLL(libassimp)

    try:
        load = LIBASSIMP.aiImportFile
        release = LIBASSIMP.aiReleaseImport
    except AttributeError:
        #OK, this is a library, but it has not the functions we need
        raise AssimpError, "assimp library not found"
    else:
        #Library found!
        load.restype = POINTER(structs.Scene)

    return(load, release, LIBASSIMP)

